<?php
namespace Drupal\gammu_smsd;

use Drupal\Core\Config\ConfigFactoryInterface;
use Drupal\gammu_smsd\GammuDatabase;
use Drupal\Core\Database\Database;
use Symfony\Component\DependencyInjection\ContainerInterface;

class GammuSendSMS extends GammuDatabase {

  /*
   * $messages have to keys number and text
   */
  public function send(array $messages){
    if(!empty($messages)){
      if(empty($this->connection)){
        $this->connection = $this->gammu_connection();
      }
      Database::setActiveConnection('gammu_db');
      foreach ($messages as $message) {
        if(empty($message[2])){
          $message[2] = NULL;
        }
        [$number, $text, $date] = $message;
        if(!empty($number) && !empty($text)){
          $this->gammu_sendsms($number, $text, $date);
        }
      }
      Database::setActiveConnection();
    }
  }

  public function gammu_sendsms($gammu_destinationnumber, $gammu_textdecoded, $SendingDateTime = NULL){

    $gammu_textdecoded = str_replace(['"', "\r\n", "\n"], ["'"," "," "], trim($gammu_textdecoded));
    $gammu_textdecoded_split = str_split($gammu_textdecoded, 153);
    $count = count($gammu_textdecoded_split);
    //send sms with command line
    if ($this->config->get('gammu_cli')) {
      $gammu_textdecoded = '"' . $gammu_textdecoded . '"';
      if ($count == 1) {
        $cmd = "gammu sendsms TEXT {$gammu_destinationnumber} -text {$gammu_textdecoded}";
        return shell_exec($cmd);
      }
      else {
        $gammu_textdecoded = '"' . $gammu_textdecoded . '"';
        $cmd = "gammu-smsd-inject -c smsdrc TEXT {$gammu_destinationnumber} -unicode -len 400 -text {$gammu_textdecoded}";
        return shell_exec($cmd);
        /* if gammu-smsd-inject doesn't work
        $out = '';
        foreach ($gammu_textdecoded_split as $split) {
          $gammu_textdecoded = '"' . $split . '"';
          $cmd = "gammu sendsms TEXT {$gammu_destinationnumber}  -text {$gammu_textdecoded}";
          $out .= shell_exec($cmd);
        }
        return $out;*/
      }
    }

    $current_user = \Drupal::currentUser();
    $CreatorID = $current_user->id() ? $current_user->id() : 'Drupal Gammu';
    if(empty($this->connection)){
      $this->connection = $this->gammu_connection();
    }
    //send sms with mysql
    if (empty($SendingDateTime)) {
      $SendingDateTime = date('Y-m-d H:i:s'); //    0000-00-00 00:00:00
    }
    $UDH_hex = '050003' . dechex(rand(16, 255)) . substr(100 + $count, -2);
    $UDH = $UDH_hex . '01';
    // UDH  050003 D5 02 01

    if ($count == 1) {
      $query_insert = $this->connection->insert('outbox')->fields([
        'DestinationNumber' => $gammu_destinationnumber,
        'TextDecoded' => $gammu_textdecoded_split[0],
        'CreatorID' => $CreatorID,
      ])->execute();
    }
    else {
      //the last inserted id of the table
      $ID = $this->connection->insert('outbox')->fields([
        'DestinationNumber' => $gammu_destinationnumber,
        'TextDecoded' => $gammu_textdecoded_split[0],
        'UDH' => $UDH,
        'MultiPart' => 'true',
        'CreatorID' => $CreatorID,
      ])->execute();

      $query_insert = $this->connection->insert('outbox')->fields([
        'UDH',
        'TextDecoded',
        'ID',
        'SequencePosition',
      ]);
      foreach (range(1, $count - 1) as $i) {
        $query_insert->values([
          'UDH' => $UDH_hex . substr(101 + $i, -2),
          'TextDecoded' => $gammu_textdecoded_split[$i],
          'ID' => $ID,
          'SequencePosition' => $i + 1,
        ]);
      }
      $query_insert->execute();
    }
    return TRUE;
  }

}
